//JPG Multi Cropper

/* Helps speed manual cropping of images. Crops all images in a folder, one by one, allowing the user to adjust the crop selection
 * Evaluates the folder, selecting files with the .jpg file extension
 * Will make a subfolder named the same as "source Cropped" in the source.
 * The files will be similarly renamed with "filename_cropped".
 * Just press space to approve a crop without adjusting.
 */

sw=screenWidth; sh=screenHeight;
print(sw, sh, getVersion());
	
Dialog.create("CROPTACULAR");
Dialog.setLocation((sw*0.25),(sh*0.25));
	Dialog.addMessage("The croppiest cropper ever!\n \n ");
	Dialog.addNumber("Number of Rows:", 8);
  	Dialog.addNumber("Number of Columns:", 12);
  	Dialog.addNumber("Gap Size:", 10);
 	Dialog.addNumber("Border Size:", 30);
 	Dialog.addString("Append Filename:","_crop", 12);
 	items=newArray("Batch process a folder", "Start from current image");
 	Dialog.addChoice("Source:", items,"Batch Process a Folder");
 	Dialog.addMessage("Croptacular will crop all the images in a folder. \n• For each image you will have the option to adjust rotation and crop.\n• For the first image draw a horizontal line\n• Next draw a rectangle to define the crop boundary\n• For the remaining images the rotation and crop will load the previous selection.\n• You may adjust either or just press space to continue on.");
 	Dialog.addMessage("Press OK to continue, then choose a folder to start.");
 	

  Dialog.show();
 	rows = Dialog.getNumber();
	 cols = Dialog.getNumber();
	  gap = Dialog.getNumber();
	   border = Dialog.getNumber();
	   	suffix= Dialog.getString();
	   	 startpoint= Dialog.getChoice();
    
// Choose a folder, or use the one with the current open image
if (startpoint=="Batch process a folder"){
			waitForUser("Choose a Source Directory");
		 dir=getDirectory("Choose a Source Directory");
		 
	;} //choose a folder
if (startpoint=="Start from current image"){dir=getDirectory("image");}
		

//make a new folder there
//splitDir= dir + "/"+File.getName(dir)+" Cropped/"; 
//File.makeDirectory(splitDir); 


//get files in the directory
templist = getFileList(dir);
list=validFileXList(templist);

if (startpoint=="Start from current image"){
	imgName= getTitle();
	I=ArrayIndex(list, imgName);
	print("I:",I);
	list=Array.slice(list,I,list.length);
	close();
	}

waitForUser("Choose a Desitnation Directory");
savedir=getDirectory("Choose a Destination Directory");


						table1 = "CROPTACULAR";
						Table.create(table1);
						Table.setLocationAndSize(sw*0.6, 50, sw*0.5, sh*0.25);
						Table.set("IMG", 0, "***");
						Table.set("File", 0, "CROPTACULAR Ver. 1.0");
						Table.set("Message", 0, "Starting...");
						Table.set("IMG", 1, ""+list.length+"/"+templist.length);
						Table.set("File", 1,  "Files had valid extensions(jpg, JPG)");
						Table.set("Message", 1, ""+templist.length-list.length+" Files were not valid or were folders");
						Table.set("Angle",0, "");
						Table.set("X pos",0,"");
						Table.set("Y pos",0,"");
						Table.set("Width",0,"");
						Table.set("Height",0,"");
						Table.set("Gap",0,"");
						Table.set("Border",0,"");
						Table.set("Notes",0,"");
						Table.set("Notes",1,"");
						Table.set("Gap",1,"");
						Table.set("Border",1,"");
						Table.set("Angle",1, "");
						Table.set("X pos",1,"");
						Table.set("Y pos",1,"");
						Table.set("Width",1,"");
						Table.set("Height",1,"");
						Table.set("Height",1,"");
						Table.update;

// open the first image in the folder, or that image is already open
		
open(dir + list[0]);
imgName=getTitle();
i=0;
		
						Table.set("File", 0, "NEXT ACTION---");
						Table.set("Message", 0, "--- Make a horizontal line - then press SPACE");
						Table.set("IMG", 2, ""+1+"/"+list.length);
						Table.set("File", 2, imgName);
						Table.set("Message", 2, "Straightening...");
						Table.set("Gap",2,gap);
						Table.set("Border",2,border);
						Table.update;
			
		//start the straighten function

		lastline=straighten();
		
						Table.set("Angle",2, lastline[4]);
						Table.set("X pos",2,"");
						Table.set("Y pos",2,"");
						Table.set("Width",2,"");
						Table.set("Height",2,"");
						Table.set("Message", 2, "Cropping...");

		//first time, there is no rectangle yet
						Table.set("File", 0, "NEXT ACTION [ ]");
						Table.set("Message", 0, " [ ] Crop adjust - then press SPACE");
						Table.update;
		
		rectBounds=newArray(50,50,200,200);
		rectBounds=gridselect(rectBounds);

						Table.set("X pos",2,rectBounds[0]);
						Table.set("Y pos",2,rectBounds[1]);
						Table.set("Width",2,rectBounds[2]);
						Table.set("Height",2,rectBounds[3]);
						Table.set("Message", 2, "Processed");
						Table.update;
		
		run("Crop");
		Overlay.remove;
		saveAs("Jpeg", savedir+File.nameWithoutExtension+suffix);
		close(); 

//for all other images

for (i=1; i<list.length; i++) {


        open(dir+list[i]);
        imgName=getTitle();
        
						Table.set("File", 0, "NEXT ACTION---");
						Table.set("Message", 0, "--- Make a horizontal line - then press SPACE");
					    Table.set("IMG", i+2, " "+i+1+"/"+lengthOf(list));
						Table.set("File", i+2, imgName);
					    Table.set("Message", i+2, "Straightening...");
						Table.update;
			       
        //load the last line
        
        makeLine(lastline[0], lastline[1],lastline[2],lastline[3]);
       	lastline=straighten();
			        Table.set("Angle",i+2, lastline[4]);
			        Table.update;
       
      	//load the last selection
      	makeRectangle(rectBounds[0], rectBounds[1], rectBounds[2], rectBounds[3]);
      	rectBounds=makegrid();
      	makeRectangle(rectBounds[0], rectBounds[1], rectBounds[2], rectBounds[3]);

				  	Table.set("File", 0, "NEXT ACTION [ ]");
					Table.set("Message", 0, " [ ] Crop adjust - then press SPACE");	
					Table.set("Message", i+2, " [ ] Cropping...");
					Table.update;
					
      //Make grid
      rectBounds=gridselect(rectBounds);
      while(selectionType()!=0){rectBounds=gridselect(rectBounds);
			     	Table.set("Message", 0, " [ ] Crop adjust - then press SPACE");
			     	Table.update;
			     	}
					Table.set("Gap",i+2,gap);
					Table.set("Border",i+2,border);
	  				Table.set("X pos",i+2,rectBounds[0]);
					Table.set("Y pos",i+2,rectBounds[1]);
					Table.set("Width",i+2,rectBounds[2]);
					Table.set("Height",i+2,rectBounds[3]);
					Table.set("Message", i+2, "Processed");
					Table.update;

	
		run("Crop");
		Overlay.remove;
	
		saveAs("Jpeg", savedir+File.nameWithoutExtension+suffix);
		close(); 

}
					Table.set("File", 0, "CROPTACULAR Ver. 1.0");
					Table.set("Message", 0, "Batch Process Completed");


//FUN!...KTIONS
//Straighten

function straighten(){
		setTool("line");
		angle=0;
		lastangle=0;
		
		while(IJ.getToolName()=="line"){
			      if(selectionType()==5){
			      getLine(x1, y1, x2, y2, lineWidth);
			      angle = getAngle(x1, y1, x2, y2);

			      getCursorLoc(x, y, z, modifiers);
			      if((isKeyDown("space")==true)&&(selectionType()==5)){setTool("rectangle");wait(1000);}
			      if(isKeyDown("shift")==true){addNotes();}
			      if(((angle!=180)&(angle!=0)&(angle!=90))&(modifiers!=16)){
			      	getLine(xx1, yy1, xx2, yy2, lineWidth);	
			      	lastline=newArray(xx1, yy1, xx2, yy2, lineWidth);
			      	lastangle = angle;
			 
			  		run("Rotate... ", "angle=angle interpolation=None enlarge");
			  		wait(100);
			  		makeLine(xx1, yy1, xx2, yy1);

			     	}
			               
		}}
		return newArray(xx1, yy1, xx2, yy2, lastangle);
		}

//load previous rectangle
//if there is no rectangle thats OK

//if there is a previous rectangle, make a grid
//if not await user to make one, either way, waiting for user to make a new grid. 

//await user to make a new rectangle
//if the user had drawn a new grid, continue on, otherwise loop until a new rectangle and a mouse release.
//Draw the grid on mouse release
//if its a new grid, Draw the bounding rectangle
//Save it


	  // Returns the angle in degrees between the specified line and the horizontal axis.
  function getAngle(x1, y1, x2, y2) {
      q1=0; q2orq3=2; q4=3; //quadrant
      dx = x2-x1;
      dy = y1-y2;
      if (dx!=0)
          angle = atan(dy/dx);
      else {
          if (dy>=0)
              angle = PI/2;
          else
              angle = -PI/2;
      }
      angle = (180/PI)*angle;
      if (dx>=0 && dy>=0)
           quadrant = q1;
      else if (dx<0)
          quadrant = q2orq3;
      else
          quadrant = q4;
      if (quadrant==q2orq3)
          angle = angle+180.0;
      else if (quadrant==q4)
          angle = angle+360.0;

      return angle;
  }

  
function gridselect(rectBounds) {

//if there is no selection user makes one
while(IJ.getToolName()=="rectangle"){
					getCursorLoc(x, y, z, modifiers);
					//print(x, y, z, modifiers);
					
//make a new grid if there is a selection AND the user is not currently holding the mouse AND the current selection is different than the prev selection
			if((selectionType()==0)&(modifiers!=16)&(modifiers!=48)&(modifiers!=32)){
					getSelectionBounds(x2, y2, width2, height2);
						if(((((rectBounds[0]==x2)&(rectBounds[1]==y2)&(rectBounds[2]==width2)&(rectBounds[3]==height2))==false)&((width2*height2)!=0))){
						rectBounds=makegrid();	
						makeRectangle(rectBounds[0], rectBounds[1], rectBounds[2], rectBounds[3]);
						}
					
					}
					if((isKeyDown("space")==true)&&(selectionType()==0)){setTool("line");wait(100);}
					if(isKeyDown("shift")==true){addNotes();}}
					
					//rectBounds=rectBounds;
		return rectBounds;
}


//if(selectionType()!=0){makeRectangle(rectBounds[0], rectBounds[1], rectBounds[2], rectBounds[3]);
//rectBounds=makegrid();
		//	} else{xC=0;yC=0;widthC=0;heightC=0;}
		
			

function makegrid(){
Overlay.remove;
getSelectionCoordinates(a,b);
run("Overlay Options...", "stroke=cyan width=3 fill=none");


//rows=8;
//cols=12;
//border=20;
//gap=20;
w=(a[1]-a[0])/cols;
h=(b[2]-b[1])/rows;
x=newArray(cols);
y=newArray(rows);

//find x coordinates without border or gap

for(i=0; i<(cols);i++){
	x[i]=a[0]+(w*i);}
	
//find y coordinates without border or gap

for(j=0; j<(rows); j++){
	y[j]=b[0]+(h*j);}
	
//draw the upper left
	makeRectangle(x[0]+border, y[0]+border, w-border-gap/2, h-border-gap/2);
	run("Add Selection...");
//draw the first row
	for(i=1; i<(cols-1); i++){
	makeRectangle(x[i]+gap/2, y[0]+border, w-gap, h-border-gap/2);
	run("Add Selection...");	
	}
//draw the upper right
	makeRectangle(x[cols-1]+(gap/2), y[0]+border, w-border-(gap/2), h-border-gap/2);
	run("Add Selection...");
	
		for(j=1; j<(rows-1);j++){
		//first
		makeRectangle(x[0]+border, y[j]+gap/2, w-border-gap/2, h-gap);
		run("Add Selection...");
		//middle
			for(i=1; i<(cols-1);i++){
			makeRectangle(x[i]+gap/2, y[j]+gap/2, w-gap, h-gap);
			run("Add Selection...");	
			}
		//last
		makeRectangle(x[cols-1]+gap/2, y[j]+gap/2, w-border-gap/2, h-gap);
		run("Add Selection...");
		}
		
//draw the lower left
	makeRectangle(x[0]+border, y[rows-1]+gap/2, w-border-gap/2, h-border-gap/2);
	run("Add Selection...");
//draw the last row
	for(i=1; i<(cols-1);i++){
	makeRectangle(x[i]+gap/2, y[rows-1]+gap/2, w-gap, h-border-gap/2);
	run("Add Selection...");	
	}
//draw the lower right
	makeRectangle(x[cols-1]+gap/2, y[rows-1]+gap/2, w-border-gap/2, h-border-gap/2);
	run("Add Selection...");
	run("Select None");

	rectBounds=newArray(a[0], b[0], (a[1]-a[0]),(b[2]-b[1]));
	return rectBounds;
}


function addNotes(){
	selectWindow(table1);
	Dialog.create("NOTES-TACULAR");
	Dialog.addString("Enter Notes", "");
	Dialog.show();
	notes=Dialog.getString();
	Table.set("Notes", i+2, notes);	
	}

function ArrayIndex(AR, term){
for (i = 0; i < AR.length; i++) {
	if(AR[i]==term){return i;}
}
return 0;
}

//accepts a File List as input, returns a list of files 
function validFileXList(templist){
	listlength=0;
	for(i=0; i<templist.length; i++){
		if (endsWith(templist[i], "JPG")||endsWith(templist[i], "jpg")) {listlength++;}}	

	//put those files in the new array, only these will be processed
			list=newArray(listlength);
			l=0;
			
	for(i=0; i<templist.length; i++){
		if (endsWith(templist[i], ".JPG")||endsWith(templist[i], ".jpg")) {
			list[l]=templist[i];
			l++;}}
	return list;

}
	
//fin
